#29 -  
proc mc:setsave {n h uh t} {
   global fset
   
   set id [tolower [ms:fl $n]]
   if {![mc:check $id -]} { return }
   set t [split $t]
   set sn [tolower [string range [lindex $t 2] 0 10]]
   if {$sn == ""} {
      mc:msg $n $fset(0)
      return
   }
   set cset ""
   set isin 0
   foreach nn [mc:modget $id 29] {
      if {[lindex $nn 0] != $sn && $nn != 0} {
          set cset [lappend cset $nn]
      }
   }
   set ee ""
   set out ""
   foreach nn [mc:modget $id 13] {
      if {[lindex $nn 2] == 1} {
         set ee [lappend ee [lindex $nn 1]]
      }
   }
   if {$ee == ""} {
      set ee "-"
   }
   set nn ""
   set nn [lappend nn $sn]
   set nn [lappend nn $ee]
   set nn [lappend nn [mc:modget $id 25]]
   if {$cset == ""} {
      set cset "\{$nn\}"
   } else {
      set cset [lappend cset $nn]
   }
   set ii 0
   set out ""
   set wr ""
   set cwr [mc:modget $id 25]
   foreach nn $ee {
      if {$ii != 0} { set out "$out$fset(1)" }
      set out "$out[format $fset(2) $nn [mc:wget $nn name $id]]"
      if {$nn == $cwr} { set wr [mc:wget $nn name $id] }
      incr ii
   }
   if {$wr == ""} {set wr $fset(4)}
   if {$out == ""} {set out $fset(4)}
   mc:modset $id 29 $cset
   mc:msg $n [format $fset(3) [join $sn] $out $wr]
}

proc mc:setlist {n h uh t} {
   global fset
   set id [tolower [ms:fl $n]]
   if {![mc:check $id -]} { return }
   if {[mc:modget $id 29] == 0} {
      mc:msg $n $fset(6)
      return
   }
   set t [split $t]
   set sn [tolower [string range [lindex $t 2] 0 10]]
   if {$sn==""} {
      set out ""
      set ii 0
      foreach nn [mc:modget $id 29] {
         if {$ii!=0} {set out "$out$fset(11)"}
         set out "$out[format $fset(12) [join [lindex $nn 0]]]"
         incr ii
      }
      mc:msg $n [format $fset(13) $out]
      return
   }
   set mset ""
   foreach nn [mc:modget $id 29] {
      if {[lindex $nn 0] == $sn && $nn != "0"} {
          set mset $nn
          break
      }
   }
   if {$mset == ""} {
      mc:msg $n [format $fset(7) [join $sn]]
      return
   }
   set wp [lindex $mset 2]
   set wpn ""
   set ii 0
   set out ""
   foreach nn [lindex $mset 1] {
      if {$ii!=0} {set out "$out$fset(8)"}
      set out "$out[format $fset(9) $nn [mc:wget $nn name $id]]"
      if {$nn==$wp} {set wpn [mc:wget $nn name $id]}
      incr ii
   }
   if {$out==""} {set out $fset(4)}
   if {$wpn==""} {set wpn $fset(4)}
   mc:msg $n [format $fset(10) [join $sn] $out $wpn]
}

proc mc:setsclear {n h uh t} {
   global fset
   set id [tolower [ms:fl $n]]
   if {![mc:check $id -]} { return }
   set sn [tolower [string range [lindex $t 2] 0 10]]   
   if {$sn != ""} {
     set tn ""
     set found 0
     foreach nn [mc:modget $id 29] {
       if {[lindex $nn 0] != $sn} {
          set tn [lappend tn $nn]
       } elseif {$nn != 0} {
          set found 1
       }
     }
     if {!$found} {
       mc:msg $n [format $fset(5b) $sn]
       return       
     }
     if {$tn == ""} {
       mc:modset $id 29 0
     } else {
       mc:modset $id 29 $tn
     }
     mc:msg $n [format $fset(5a) $sn]
   } else {
     mc:modset $id 29 0
     mc:msg $n $fset(5)
   }
}

proc mc:setput {n h uh t} {
   global fset
   
   set id [tolower [ms:fl $n]]
   if {![mc:check $id -]} {return}
   if {[mc:modget $id 29] == 0} {
      mc:msg $n $fset(6)
      return
   }
   set t [split $t]
   set sn [tolower [string range [lindex $t 2] 0 10]]
   if {$sn == ""} {
      mc:msg $n $fset(0)
      return
   }
   set mset ""
   foreach nn [mc:modget $id 29] {
      if {[lindex $nn 0] == $sn && $nn != "0"} {
          set mset $nn
          break
      }
   }
   if {$mset == ""} {
      mc:msg $n [format $fset(7) [join $sn]]
      return
   }
   set wwr [lindex $mset 1]
   set tth ""
   foreach nn [mc:modget $id 13] {
	   set nn [lreplace $nn 2 2 0]
	   set tth [lappend tth $nn]
   }
   set tth1 ""
   foreach nn $tth {
      if {[lsearch -exact $wwr [lindex $nn 1]] != -1 && [mc:harksok [lindex $nn 0] $id] >= 0} {
	      set pars [split [mc:wget [lindex $nn 0] wear] ""]
	      set ipoff 0
	      foreach p $tth1 {
	         set ipoff 0
	         foreach pp $pars {
	            if {[mc:checkin $pp [mc:wget [lindex $p 1] wear $id]] && [lindex $p 2]} {
	               set ipoff 1
	               break
	            }
         	 }
     	  }
     	  if {!$ipoff} {
	     	  set nn [lreplace $nn 3 3 [lreplace [lindex $nn 3] 1 1 0]]
          	  set nn [lreplace $nn 2 2 1]
      	  }
      }
      set tth1 [lappend tth1 $nn]
   }
   mc:modset $id 13 $tth1
   mc:modset $id 25 [lindex $mset 2]

   set wp [lindex $mset 2]
   set wpn ""
   set ii 0
   set out ""
   foreach nn [lindex $mset 1] {
      if {$ii!=0} {set out "$out$fset(8)"}
      set out "$out[format $fset(9) $nn [mc:wget $nn name $id]]"
      if {$nn==$wp} {set wpn [mc:wget $nn name $id]}
      incr ii
   }
   if {$out==""} {set out $fset(4)}
   if {$wpn==""} {set wpn $fset(4)}
   mc:msg $n [format $fset(10) [join $sn] $out $wpn]
}
